###
#######################################################
#		Home Free v3.24 (Nearly Null)
#     
#    		Created by Solution Scripts
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# Selling the code for this program without prior written consent is
# expressly forbidden. In all cases
# copyright and header must remain intact.
#
#######################################################

package Account;

sub initialize {
$manager_header="header.txt";
$manager_footer="footer.txt";

package main;

$thisurl = $ENV{'SCRIPT_NAME'};
$mail_url = $ENV{'SERVER_NAME'};
$query=$ENV{'QUERY_STRING'};
$pathinfo = $ENV{'PATH_INFO'}; 
$pathinfo =~ s/\///;
if ($pathinfo =~ /\./) {
	@pi = split(/\//,$pathinfo);
	@pi = reverse(@pi);
	$pathinfo = $pi[0];
	if ($pathinfo =~ /\./) { $pathinfo = ''; }
}


unless ($pathinfo) { $pathinfo = "english"; }
if (-e "$pathinfo.lang") {
	require "$pathinfo.lang";
}
else {
	require "english.lang" || print "$!";	
}

$cgiurl = $ENV{'SCRIPT_NAME'};
$cgiurl = $cgiurl . "/" . $pathinfo;

$version = "3.2";

@char_set = ('a'..'z','0'..'9');

## SET PAGES,DIRECTORIES USER CAN NOT EDIT OR SEE ##
%bad_files = ("guestbook.html","bad","gbook.dat","bad",".quota","bad");
%bad_dirs = ("wwwboard","bad","_data","bad");

## SET GOOD FILE TYPES AND WHAT THEY ARE ##
%good_types = (".htm","html",".html","html",".gif","image",".jpg","image",".jpeg","image",".txt","text");
## VERIFY THE FILE IS WHAT IT SAYS IT IS ##
%verify_types = (".gif","GIF",".jpg","JFIF",".jpeg","JFIF",".zip","pk");

open (DAT,"<$main::path/filetypes.txt");
$file_types = <DAT>;
close (DAT);
@tfile = split(/\r/,$file_types);
foreach (@tfile) {
	if ($_ eq "\.shtml") {
		$good_types{$_} = "html";
	}
	else {		
		$good_types{$_} = "file";
	}
}

## GET BROWSER TYPE ##
if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/) {
	$Account::browser = "IE";
}
else { $Account::browser = "Netscape"; }


### FILE NAMES ###
$files::new = "$url_to_cgi/new.cgi/$pathinfo";
$files::manager = "$url_to_cgi/manager.cgi/$pathinfo";
$files::manage = "$url_to_cgi/user_manage.cgi/$pathinfo";
$files::files = "$url_to_cgi/user_files.cgi/$pathinfo";
$files::dirs = "$url_to_cgi/user_dirs.cgi/$pathinfo";
$files::uploads = "$url_to_cgi/user_uploads.cgi/$pathinfo";
$files::gbook = "$url_to_cgi/user_gbook.cgi/$pathinfo";
$files::pref = "$url_to_cgi/user_pref.cgi/$pathinfo";
$files::wwwboard = "$url_to_cgi/user_wwwboard.cgi/$pathinfo";
$files::templates = "$url_to_cgi/user_templates.cgi/$pathinfo";
$files::ez_web = "$url_to_cgi/ez_web.cgi/$pathinfo";
$files::ftp_import = "$url_to_cgi/user_ftp_import.cgi/$pathinfo";
$files::formmail = "$url_to_cgi/user_formmail.cgi/$pathinfo";
$files::search = "$url_to_cgi/search.cgi/$pathinfo";

## SET HOME FREE COMMENTS - DO NOT EDIT ##
$start_head ="<!-- START HOME FREE HEADER CODE -->\n";
$start_foot ="<!-- START HOME FREE FOOTER CODE -->\n";
$end_head ="<!-- END HOME FREE HEADER CODE -->\n";
$end_foot ="<!-- END HOME FREE FOOTER CODE -->\n";

## SET DEFAULT COLORS ##
unless ($over_bg) { $over_bg= "white"; }
unless ($table_bg) { $table_bg= "white"; }
unless ($table_bg2) { $table_bg2= "#e1e1e1"; }
unless ($table_head_bg) { $table_head_bg= "\#003C84"; }
unless ($text_color) { $text_color= "black"; }
unless ($link_color) { $link_color= "blue"; }
unless ($text_table) { $text_table= "black"; }
unless ($text_table_head) { $text_table_head= "white"; }
unless ($text_highlight) { $text_highlight= "red"; }
unless ($font_face) { $font_face= "arial"; }
unless ($font_size) { $font_size= "-1"; }
@colors=($table_bg,$table_bg2);

## PARSE BUFFER AND QUERY STRING ##
$something_in=0;

## FILE UPLOADS ##
if ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
	$something_in=1;
	&multi_parse;
}
else {
	if ($query) { @pairs=split(/&/,$query); }
	else {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
		@pairs = split(/&/, $buffer);
	}	
	foreach $pair (@pairs) {
		$something_in=1;
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if ($INPUT{$name}) { $INPUT{$name} = $INPUT{$name}.",".$value; }
		else { $INPUT{$name} = $value; }
	}
}

## NOTHING ENTERED SEND TO LOGIN PAGE ##
unless ($something_in) { &main::main; }

## SET DATE AND TIME ##
$time = time;
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
$mon++;
$year += 1900;
$now = "$mon.$mday.$year";

}

########### FIRST LOGIN - SET SESSION ##########
sub first_log {


$account = $main::INPUT{'account'};
$account = "\L$account\E";

if ($main::INPUT{'cata'}) {
	$cata = $main::INPUT{'cata'};
	$cata_acc = "$main::INPUT{'account'}|$main::INPUT{'cata'}";
}
else {
	$cata="accounts";
	$cata_acc = $main::INPUT{'account'};
}	

$password = $main::INPUT{'password'};

my $got_acc = &get_account;

unless ($got_acc) {
	&Account::pretty_error("$lang::a1 <B>$account</B>, $lang::a2");
}

unless ($password eq $pwd) {
	&Account::log_it('2',$lang::a3,"$account - $cata","");
	&Account::pretty_error($lang::a3);
}

if ($onhold) {
	&Account::pretty_error("$lang::a4<BR>$onhold");
}


## GENERATE RANDOM SESSION VARIABLE ##
srand($main::time);
$session ="";
@passset = ('a'..'z', 'A'..'Z', '1'..'9');
for ($i = 0; $i < 15; $i++) {
	$randum_num = int(rand($#passset + 1));
	$session .= @passset[$randum_num];
}

if ($main::log_ips) {
	$Account::last_ip = $main::ENV{'REMOTE_ADDR'};
}

$Account::last_log = $main::time;
$Account::session_str = $session;

## CREATE FORM VARIABLES ##
$hidden_variables = "<INPUT TYPE=HIDDEN NAME=\"account\" VALUE=\"$cata_acc\">\n";
$hidden_variables .= "<INPUT TYPE=HIDDEN NAME=\"session\" VALUE=\"$session\">\n";

&get_base_path;
 
&space_file_check;

&print_account;

&main::main_menu;
exit;
}

########## VERIFY USER ##########
sub verify_user {

@cataacc = split(/\|/,$main::INPUT{'account'});

if ($cataacc[1]) {
	$cata = $cataacc[1];
}
else { 
	$cata = '';
}

$account = $cataacc[0];
$account = "\L$account\E";

$cata_acc = $main::INPUT{'account'};
$password = $main::INPUT{'password'};
unless ($cata) { $cata="accounts"; }

$session = $main::INPUT{'session'};

my $got_acc = &get_account;

unless ($got_acc) {
	&Account::pretty_error("$lang::a1 <B>$account</B>, $lang::a2");
}

if ($onhold) {
	&Account::pretty_error("$lang::a4<BR>$onhold");
}

if ($session ne $Account::session_str) { 
	&Account::pretty_error("Bad session");
}

$total_time = $main::time - $Account::last_log;
if ($total_time > 5400) {
		&Account::pretty_error("session time");
}

$Account::last_log = $main::time;

## CREATE FORM VARIABLES ##
$hidden_variables = "<INPUT TYPE=HIDDEN NAME=\"account\" VALUE=\"$main::INPUT{'account'}\">\n";
$hidden_variables .= "<INPUT TYPE=HIDDEN NAME=\"session\" VALUE=\"$session\">\n";

&get_base_path;
&print_account;

}

########## GET BASE DIR INFO ##########
sub get_base_path {

$org_acc = "$account";



unless ($cata eq "accounts") {

	%catah = &Account::get_cata_hash;
	@abbo = split(/\|/,$catah{$cata});
	
	if ($abbo[0]) {
		$org_acc = "$abbo[0]/$account";
	}

	$file_header = $abbo[3];
	$file_footer = $abbo[4];
	$manager_header = $abbo[5];
	$manager_footer = $abbo[6];
	
}

unless ($file_header) { $file_header="header_html.txt"; }
unless ($file_footer) { $file_footer="footer_html.txt"; }
unless ($manager_header) { $manager_header="header.txt"; }
unless ($manager_footer) { $manager_footer="footer.txt"; }
if (($manager_header eq "Default") || ($manager_header eq "default")) { $manager_header="header.txt"; }
if (($manager_footer eq "Default") || ($manager_footer eq "default")) { $manager_footer="footer.txt"; }


if ($Account::hf_on eq "off") {
	$file_header="";
	$file_footer="";
}


## PATHS ##
$dir_acc = "$main::free_path/$org_acc";

## URL ##
$url_acc = "$main::url/$org_acc";

$main::dir = $main::INPUT{'dir'};
$main::dir =~ s/^\///;

if ($main::dir =~ /\.\./) {
	&Account::log_it('2',$lang::a5,"Account - $account Category - $cata Directory - $main::INPT{'dir'}","");
	&pretty_error($lang::a6);
}

if ($main::dir) {
	$main::dir_plus = "$Account::dir_acc/$main::dir";
	$main::url_plus = "$Account::url_acc/$main::dir";
	$main::text_dir = $main::dir;
}
else {
	$main::dir_plus = $Account::dir_acc;
	$main::url_plus = $Account::url_acc;
	$main::text_dir = $lang::a10;
}


}

############ CHECK SPACE - LIST FOLDERS FILES ###########
sub space_file_check {

$num_files=0;
$num_dirs=0;

&dir_lists("$dir_acc");

unless (-e "$dir_acc/_data") {
	mkdir("$dir_acc/_data", 0777) || &error("$lang::a7 - $dir_acc/_data");
	chmod(0777,"$dir_acc/_data");
}

open (ACC, ">$dir_acc/_data/dirs_hf.txt") || &main::error("$lang::a8 - $dir_acc/_data/dirs_hf.txt");
print ACC $dir_lists;
close (ACC);

open (ACC, ">$dir_acc/_data/files_hf.txt") || &main::error("$lang::a8 - $dir_acc/_data/files_hf.txt");
print ACC $file_lists;
close (ACC);

$size=$total_k;

}

########## DIRECTORY LISTINGS ##########
sub dir_lists {

my $direc = $_[0];
my (@dirs,$new_dir);

opendir(DIR,$direc);
@dirs = grep {!(/^\./) && -d "$direc/$_" } readdir(DIR);
close DIR;
@dirs = sort(@dirs);

opendir (DIR, "$direc");
@files = grep {!(/^\./) && -f "$direc/$_"}  readdir(DIR);
close (DIR); 
@files = sort(@files);

my @parsed_dir = split(/\//,$direc);
@parsed_dir = reverse(@parsed_dir);

my $dir = $parsed_dir[0];

foreach $file(@files) {
	$show_file = $file;
	$show_file =~ s/$dir_acc\///i;
	$file_lists .= "$direc/$file\n";
	$num_files++;

	@stats = stat("$direc/$file");
	$mtime = $stats[9];
	$atime = $stats[8];
	$size = $stats[7];
	$size = $size /1000;
	$total_k = $size + $total_k;
}

	
for $new_dir(0..$#dirs) {
	$show_dir = "$direc/$dirs[$new_dir]";
	$show_dir =~ s/$dir_acc\///i;
	unless ($main::bad_dirs{$show_dir}) {
		$file_lists .= "$direc/$dirs[$new_dir]\n";
		$dir_lists .= "$show_dir\n";
		$num_dirs++;
		&dir_lists("$direc/$dirs[$new_dir]",$blank);
	}

}


}

########## DIRECTORY SELECT LIST ###########
sub dir_select_list {

my $curr_dir = shift;

undef $/;
open (ACC, "$dir_acc/_data/dirs_hf.txt") || &main::error("$lang::a9 $dir_acc/_data/dirs_hf.txt");
$dir_data = <ACC>;
close (ACC);
$/ = "\n";

@dir_array = split(/\n/,$dir_data);

$html = "<OPTION value=\"\">$lang::a10\n";

foreach $line (@dir_array) {
	
	$html .= "<OPTION value=\"$line\"";
	if ($curr_dir eq $line) {
		$html .= " SELECTED>$line \*\n";
	}
	else {
		$html .= ">$line\n";
	}
}

return($html);

}

sub size_test {

my $file_name = $_[0];
my $content = $_[1];

open (FILE, ">$file_name.temp");
print FILE $content;
close (FILE);

@stats = stat("$file_name.temp");
$sizes = $stats[7];
$sizes = $sizes /1000;
@stats = stat("$file_name");
$tsize = $stats[7];
$tsize = $tsize /1000;
$t_size = $sizes - $tsize + $Account::size;
$main::total_size += $Account::size_added;

if ($t_size > $main::total_size) {
	unlink ("$file_name.temp") || &Account::error("$lang::a8 - $dir_plus/$file");
	return(0);
}

$Account::size = $t_size;

unlink ("$file_name.temp") || &Account::error("$lang::a8 - $dir_plus/$file");

return(1);
}

########## LOGGING ##########
sub log_it {

$level = $_[0];
$subject = $_[1];
$more = $_[2];
$log_url = $_[3];

if ($main::log_level >= $level) {
	open (ACC, ">>$main::path/hf.log");
	print ACC "$level\|\%\|$main::time\|\%\|$Account::account\|\%\|$Account::cata\|\%\|$subject\|\%\|$more\|\%\|$log_url\|\%\|$main::ENV{'REMOTE_ADDR'}\n";
	close (ACC);
}

}

########## HEADER ##########
sub header {

return if $print_header;
$print_header = 1;

if ($main::pheader) {
	print "Content-type: text/html\n\n ";
}

my $title = $_[0];
my $title1 = $_[1];
my $title2 = $_[2];

print "<HTML><HEAD><TITLE>$main::free_name</TITLE></HEAD>\n";
print "<body bgcolor=$main::over_bg text=$main::text_color link=$main::link_color alink=$main::link_color vlink=$main::link_color>\n";

if (-e "$main::path/$manager_header") {
	undef $/;
	open (HEAD, "$main::path/$manager_header");
	$head = <HEAD>;
	close (HEAD);
	
	unless ($manager_header eq "header.txt") {
		$head =~ s/.*\n//;
	}
	print "$head<BR>";	
	$/="\n";
}

if ($title) {

print <<EOF;
</CENTER>
<font face=arial size=+1><B>
<A HREF="$files::manager?account=$Account::cata_acc&session=$Account::session&action=main">$lang::home</A> :: 
EOF

	if ($title1) {
		print "<A HREF=\"$ENV{'HTTP_REFERER'}\">$title</A>";
	}
	else {
		print "$title";
	}

	if (($title1) && !($title2)) {
		print " :: $title1";
	}

	if ($title2) {
		print " :: $title2";
	}

	print "</B></FONT>\n";
}
print "<BR><BR>\n";

}

########## FOOTER ##########
sub footer {

if (-e "$main::path/$manager_footer") {
	undef $/;
	open (HEAD, "$main::path/$manager_footer");
	$head = <HEAD>;
	close (HEAD);
	
	unless ($manager_footer eq "footer.txt") {
		$head =~ s/.*\n//;
	}
	print "$head<BR>";	
	$/="\n";
}

}

########## PRETTY ERROR MESSAGE ##########
sub pretty_error {

my $error_msg = shift;

if ($error_msg =~ /session time/i) {
	$error_msg = $lang::a11 . "<BR><BR><A HREF=\"$files::manager\">$lang::a12</A>\n";
}


&Account::header;
print <<EOF;
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=400>
<TR><TD>
<FONT FACE=$font_face size=$font_size>
<B>$lang::a13</B>
<BR><BR>
$error_msg
</TD></TR></TABLE><BR><BR>
EOF

&Account::footer;
exit;

}

########## AN ERRROR ##########
sub error {

my $error_msg = shift;

print <<EOF;
<TABLE CELLPADDING=5 CELLSPACING=0 BORDER=1>
<TR><TD>
<FONT FACE=$font_face SIZE=$font_size>
<B>$lang::a14</B>
<BR><BR>
$lang::a15
<BR><BR>
<I>$error_msg - $!</I>
</TD></TR></TABLE>
EOF

&Account::log_it('1',$lang::a14,"$error_msg - $!","");	

&Account::footer;
exit;

}

########## AN ERRROR ##########
sub main::error {

my $error_msg = shift;

print <<EOF;
<TABLE CELLPADDING=5 CELLSPACING=0 BORDER=1>
<TR><TD>
<FONT FACE=$font_face SIZE=$font_size>
<B>$lang::a14</B>
<BR><BR>
$lang::a15
<BR><BR>
<I>$error_msg - $!</I>
</TD></TR></TABLE>
EOF

&Account::log_it('1',$lang::a14,"$error_msg - $!","");	

&Account::footer;
exit;

}
1;

